#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>

int error;

struct oneSect {
unsigned char track;
unsigned char head;
unsigned char sector;
unsigned char size;
};

oneSect sectTbl[20];		// maximalne 20 sektoru na stopu

unsigned tracks;		// pocet stop
unsigned sectors;		// sektoru na stopu
unsigned heads;			// pocet hlav (0-1)
unsigned drive;			// PC - drive
unsigned diskType;		// typ disku

unsigned char memory[ (9*512*3) + (9*256) ];

/*
	    00h = no disk
	    01h = regular disk in regular drive
	    02h = regular disk in high-capacity drive
	    03h = high-capacity disk in high-capacity drive
	    04h = 720K disk in 720K drive

*/

unsigned curTrack;
unsigned curHead;

unsigned char statusByte;

void far *tabPtr;
unsigned char tabParam[11] =
{ 0xdf, 2, 0x25, 2, 9, 0x2a, 0xff, 0x50, 0xe5, 0x19, 8 };

void store()
{
  asm { xor ax, ax; mov es, ax; les bx, es:[0x78]; }
  asm { mov word ptr tabPtr, bx; mov word ptr tabPtr + 2, es; }
  asm {
	xor	ax, ax
	mov	es, ax
	mov	ax, offset tabParam
	mov	es:[1eh * 4], ax
	mov	ax, seg tabParam
	mov	es:[1eh * 4 + 2], ax
  }
}

void restore()
{
  asm {
	xor	ax, ax
	mov	es, ax
	mov	ax, word ptr tabPtr
	mov	es:[1eh * 4], ax
	mov	ax, word ptr tabPtr + 2
	mov	es:[1eh * 4 + 2], ax
  }
}

void diskReset()
{
  asm {
	mov	ax, 0
	mov	dl, byte ptr drive
	int	13h
  }
}

int format( unsigned track, unsigned head,
		 unsigned drive, unsigned sectors, void far *table )
{
  error = 0;
  _AH = 0x5;		// format track
  _AL = sectors;	// sectors on track
  _CH = track;
  _CL = 1;	        // begin sector
  _DH = head;
  _DL = drive;
  _ES = FP_SEG(table);
  _BX = FP_OFF(table);
  asm int 13h;
  asm adc error, 0;
  return error;
}

void set_type()
{
  _AH = 0x17;		// set type
  _AL = ::diskType;	// typ disku
  _DL = ::drive;
  asm int 13h;
  error = 0;
  _AH = 0x18;		// set media type for format
  _DL = ::drive;
  _CH = ::tracks - 1;
  _CL = ::sectors;
  asm int 13h;
  error = _AH;
  _AH = 0;
  _DL = ::drive;
  asm int 13h;
}

void prepare_tbl()
{
  unsigned char tblInter[9] = { 1, 8, 6, 4, 2, 9, 7, 5, 3 };

  int s;
  int pos = 0;
  for ( s = 1; s <= sectors; pos++,s++)
    {
      sectTbl[pos]. track = curTrack;
      sectTbl[pos]. head  = curHead;
      sectTbl[pos]. sector = tblInter[s-1];
      if ( (curTrack == 0) && ( curHead == 1 ) )
	{
	  sectTbl[pos]. size = 1;
	  tabParam[3] = 1;
	}
       else
	{
	  sectTbl[pos]. size = 2;
	  tabParam[3] = 2;
	}
    }
}

void readTrack( void *m )
{
  if ( ( curTrack == 0 ) && ( curHead == 1 ) ) tabParam[3] = 1;
    else tabParam[3] = 2;
  _CH = curTrack;
  _CL = 1;
  _DH = curHead;
  _DL = ::drive;
  _ES = FP_SEG(m);
  _BX = FP_OFF(m);
  _AH = 2;
  _AL = sectors;
  asm int 13h;
  error = _AH;
}

void writeTrack( void *m )
{
  if ( ( curTrack == 0 ) && ( curHead == 1 ) ) tabParam[3] = 1;
    else tabParam[3] = 2;
  _CH = curTrack;
  _CL = 1;
  _DH = curHead;
  _DL = ::drive;
  _ES = FP_SEG(m);
  _BX = FP_OFF(m);
  _AH = 3;
  _AL = sectors;		       // sektor
  asm int 13h;
  error = _AH;
}

void verifyTrack()
{
  if ( ( curTrack == 0 ) && ( curHead == 1 ) ) tabParam[3] = 1;
    else tabParam[3] = 2;
  _CH = curTrack;
  _CL = 1;
  _DH = curHead;
  _DL = ::drive;
  _AH = 4;
  _AL = sectors;
  asm int 13h;
  error = _AH;
}

void format_drive()
{
  int errX;
  printf("\n\n");
  diskReset();
  for ( curTrack = 0; curTrack < tracks; curTrack++)
    for ( curHead = 0; curHead <= heads; curHead++)
      {
	printf("Track : %4u    Head : %1u", curTrack, curHead);
	putch( 0x0d );
	prepare_tbl();
	errX = 10;
	lbl1:
	format( curTrack, curHead, drive, sectors, &sectTbl );
	verifyTrack();
	errX--;
	if ( error != 0 )
	  {
	    if ( errX == 5 ) diskReset();
	    if ( errX > 0 ) goto lbl1;
	    printf("\n\nChyba ... ");
	    restore(); exit(1);
	  }
      }
  printf("\n\nDisketa byla uspesne naformatovana ...\n");
}

void readSystem()
{
  unsigned ptr = 0;
  unsigned errX;

  printf("\nCtu system ... ");
  diskReset();
  for ( curTrack = 0; curTrack <= 1; curTrack++ )
    for ( curHead = 0; curHead <= 1; curHead++ )
      {
	errX = 3;
	lbl1:
	readTrack( &memory[ptr] );
	if ( error != 0 )
	  {
	    errX--;
	    if ( errX > 0 ) goto lbl1;
	    printf("\n\nChyba ...");
	    restore(); exit(1);
	  }
	if ( ( curTrack == 0 ) && ( curHead == 1 ) )
	  ptr += 9 * 256; else ptr += 9 * 512;
      }
  printf("\nSystem byl uspesne precten ... ");
}

void writeSystem()
{
  unsigned ptr = 0;

  int errX;
  printf("\nUkladam system ... ");
  diskReset();
  for ( curTrack = 0; curTrack <= 1; curTrack++ )
    for ( curHead = 0; curHead <= 1; curHead++ )
      {
	errX = 5;
	lbl1:
	errX--;
	writeTrack( &memory[ptr] );
	if ( error != 0 )
	  {
	    if ( errX > 0 ) goto lbl1;
	    printf("\n\nChyba ...");
	    restore(); exit(1);
	  }
	if ( ( curTrack == 0 ) && ( curHead == 1 ) )
	  ptr += 9 * 256; else ptr += 9 * 512;
      }
  printf("\nSystem byl uspesne ulozen ... ");
}

void wait( char s[] )
{
  printf(s);
  getch();
}

int another()
{
  printf("Dalsi (A/ ) ? ");
  return toupper(getch()) == 'A';
}

void goFormat()
{
lbl2:
  wait("\nVlozte prosim do mechaniky disketu, kterou chcete naformatovat ... ");
  set_type();
  if ( error == 0x80 ) goto lbl2;
  if ( error != 0 )
    {
      printf("\nInvalid BIOS ... \n");
      exit(1);
    }
  format_drive();
  if ( another() ) goto lbl2;
}

void goSystem()
{
lbl2:
  wait("\nVlozte do mechaniky disketu se systemem ... ");
  readSystem();
  if ( memory[ 9*512] != 0xfc )
    {
      printf("\n\nTo neni systemova disketa !!!!\n");
      goto lbl2;
    }
  wait("\nVlozte do mechaniky disketu na kterou ma byt system ulozen ... ");
  writeSystem();
  if ( another() ) goto lbl2;
}

void goBoth()
{
lbl1:
  wait("\nVlozte do mechaniky disketu se systemem ... ");
  readSystem();
  if ( memory[ 9*512] != 0xfc )
    {
      printf("\n\nTo neni systemova disketa !!!!\n");
      goto lbl1;
    }
lbl2:
  wait("\nVlozte do mechaniky disketu, kterou chcete naformatovat ... ");
  set_type();
  if ( error == 0x80 ) goto lbl2;
  if ( error != 0 )
    {
      printf("\nInvalid BIOS ... \n");
      exit(1);
    }
  format_drive();
  writeSystem();
  if ( another() ) goto lbl2;
}

void select()
{
  printf("\n\n");
  printf("SHARP format,   verze 1.00,    Copyright (c) 1992 Perex soft\n");
  printf("============================================================\n\n");
  printf("\n\nVyberte mechaniku se kterou se bude pracovat (A/B) ? : ");
  if ( toupper(getch()) == 'B' ) drive = 1; else drive = 0;
  printf("\nVybrana mechanika : %c", drive + 'A');
  _AH = 8;		// get current drive parameters
  _DL = ::drive;
  asm push si;
  asm push di;
  asm int 13h;
  asm pop di;
  asm pop si;
  if ( _CL == 17 )
    {
      tracks = 80; sectors = 9; heads = 1; diskType = 2;
      printf("\nKapacita disku :  720 kB   3 1/2\n\n");
    }
   else
    {
      lbl1:
      printf("\n\nZvolte pozadovanou kapacitu : \n\n");
      printf("       1 -     360 kB\n");
      printf("       2 -     720 kB\n");
      printf("                               ");
      switch ( getch() ) {
	case '1': tracks = 40; sectors = 9; heads = 1; diskType = 2; break;
	case '2': tracks = 80; sectors = 9; heads = 1; diskType = 2; break;
	case 0x1b: exit(1);
      default: goto lbl1;
      };
      if ( tracks == 40 )
	printf("\nKapacita disku :  360 kB   5 1/4\n\n");
       else
	printf("\nKapacita disku :  720 kB   5 1/4\n\n");
    }
lbl2:
  printf("Vyber cinnosti : \n\n");
  printf("      1 -   formatovani\n");
  printf("      2 -   prehrani systemu\n");
  printf("      3 -   formatovani a prehrani systemu\n");
  printf("      4 -   konec\n");
  printf("                            ");
  switch ( getch() ) {
    case '1': goFormat(); break;
    case '2': goSystem(); break;
    case '3': goBoth(); break;
    case '4': return;
    default: goto lbl2;
  }
}

void main()
{
  store();
  select();
   restore();
}