; ============================================
;
;      EMULACE RADICE WESTERN 2795
;
; Vsechno se musi pred pouzitim invertovat !!!
;
; ============================================

		MOTORDLY = 1500		; 10 sec

		EVEN
track		db	0		; stopa
		EVEN
sector		db	0		; sektor
		EVEN
side		db	0		; strana
		EVEN
busycnt		db	0		; citac busy
		EVEN
pc_drive	db	0		; zatim jenom B:
		EVEN
fdd_err		db	0		; chyba ???
		EVEN
busy_status	db	0		; co se ma delat po busy
		EVEN
buf_ptr		dw	0		; pointer do bufferu
		EVEN
fddon		db	0		; je floppy on?
		EVEN
sts_ok		db	0		; pridava se k OK statusu ...
		EVEN
sect_size	dw	0		; velikost sektoru
		EVEN
cfgDisk		db	0
		EVEN
only_256	db	0		; pouze 256 byte na sektor ?

		EVEN

tblPrm		db	0dfh, 2, 25h, 2, 9, 2ah, 0ffh, 54h, 0e5h, 0fh, 8

Old1E		dw	0, 0

busy		macro	XX

		mov	cs:busycnt, 1
		mov	cs:busy_status, XX

		endm

sect256	        proc	near

		push	es
		push	bx
		les	bx, dword ptr cs:Old1E
		mov	byte ptr es:[bx + 3], 1		; 256 byte na sector
		pop	bx
		pop	es
		ret

sect256		endp

sect512		proc	near

		push	es
		push	bx
		les	bx, dword ptr cs:Old1E
		mov	byte ptr es:[bx + 3], 2		; 512
		pop	bx
		pop	es
		ret

sect512		endp

		EVEN

fddbuf		db	512 dup ( 0 )

		EVEN

set_secsize	proc	near

		push	dx
		cmp	cs:only_256, 1		; jedeme pouze na 256 byte
		jz	@@x
		mov	dl, cs:track
		not	dl
		mov	dh, cs:side
		and	dh, 1
		mov	bx, offset fddbuf
		cmp	dh, 1
		jnz	@@01
		cmp	ch, 0			; nulta stopa na 1 hlave
		jnz	@@01
@@x:		mov	cs:sect_size, 256
		call	sect256			; sektory dlouhe 256 byte
		jmp	@@02
@@01:		mov	cs:sect_size, 512
		call	sect512
@@02:		pop	dx
		ret

set_secsize	endp

		EVEN

laststep	dw	offset step_in

		EVEN

out_fddcmd	proc	near	; zapis prikazu

		pop	bx
		push	bx
		mov	cs:fdd_err, 0	; chyba neni (zatim)
		not	bh		; invertuj
		mov	bl, bh
		and	bl, 11100000b
		jz	@@1		; restore nebo seek
		test	bl, 10000000b
		jnz	@@2		; cteci prikazy
		cmp	bl, 00100000b	; step
		jnz	@@0001
		mov	bx, cs:laststep
		jmp	bx
@@0001:		cmp	bl, 01000000b	; step-in
		jnz	@@0002
step_in:	dec	cs:track	; zvys stopu ...
		mov	cs:laststep, offset step_in
		jmp	@@01
@@0002:
step_out:	inc	cs:track
		mov	cs:laststep, offset step_out
@@01:		busy	<0>		; generuj pri cteni statusu busy
		cmp	cs:track, 0ffh
		mov	cs:sts_ok, 0	; nic se k statusu nepridava
		jnz	@@02
		mov	cs:sts_ok, 00000100b	; track 0
@@02:		pop	bx
		ret
@@1:		test	bh, 00010000b
		jnz	@@01		; seek
		mov	cs:track, 0ffh	; pri restore je stopa nulova
		jmp	@@01
@@2:		mov	cs:sts_ok, 0	; k statusu ok se nic nepridava
		cmp	bl, 10000000b	; read sector
		jnz	@@4
		call	readsec
		pop	bx
		ret
@@4:		cmp	bl, 10100000b	; write sector
		jnz	@@5
		mov	cs:buf_ptr, 0	; nuluj pointr do bufferu
		busy	<2>		; zapis sektor
		pop	bx
		ret
@@5:		mov	bl, bh
		and	bl, 11110000b
		cmp	bl, 11010000b	; force int
		jnz	@@6
		pop	bx
		ret
@@6:		cmp	bl, 11000000b	; read addr
		jnz	@@7
		mov	cs:buf_ptr, 0
		mov	cs:sect_size, 6	; delka znacky
		busy	<1>             ; read sector
		mov	bl, cs:track
		mov	cs:fddbuf, bl
		mov	bl, cs:sector
		mov	cs:fddbuf + 1, bl
		mov	bl, cs:side
		mov	cs:fddbuf + 2, bl
		mov	bl, 10b
		not	bl
		mov	cs:fddbuf + 3, bl
		mov	bx, 0
		mov	word ptr cs:fddbuf + 4, bx
		pop	bx
		ret
@@7:		pop	bx
		mov	bx, 8
		jmp	error

out_fddcmd	endp

		EVEN

track0		db	0

		EVEN

inp_fddstate	proc	near	; stav radice

		cmp	cs:busycnt, 0	; nulove ?
		jz	@@1		; ok, jedeme dal
		dec	cs:busycnt	; odecti
		mov	bl, 00000001b	; busy
		not	bl
		ret
@@1:		cmp	cs:fdd_err, 0	; nulove ?
		jz	@@2
		mov	bl, 00011000b	; seek or error, crc err
		not	bl
		ret
@@2:            cmp	cs:busy_status, 1	; po read sector
		jz	@@20
		cmp	cs:busy_status, 2	; write sector
		jnz	@@00
@@20:		mov	bx, cs:buf_ptr
		cmp	bx, cs:sect_size    ; vsechny byty uz jsou vycerpany?
		jnz	@@21		    ; ne
		cmp	cs:busy_status, 2    	; write sector
		jnz     @@22
		call    writesec
		jmp	@@1
@@22:		mov	cs:busy_status, 0   ; ok, precteno ...
		mov	bl, 00000000b	    ; all ok...
		not	bl
		ret
@@21:		mov	bl, 00000011b	; DRQ and busy
		not	bl
		ret
@@00:		mov	bl, 00000000b	; all ok ...
		or	bl, cs:sts_ok
		not	bl
		ret

inp_fddstate	endp

		EVEN

out_fddtrack	proc	near

		pop	bx
		mov	cs:track, bh
		ret

out_fddtrack	endp

		EVEN

inp_fddtrack	proc	near

		mov	bl, cs:track
		ret

inp_fddtrack	endp

		EVEN

out_fddsector	proc	near

		pop	bx
		mov	cs:sector, bh
		ret

out_fddsector	endp

		EVEN

inp_fddsector	proc	near

		mov	bl, cs:sector
		ret

inp_fddsector	endp

		EVEN

out_fdddata	proc	near

		pop	bx
		push	bx
		push	ax
		mov	al, bh
		mov	bx, cs:buf_ptr
		cmp	bx, cs:sect_size		; pres ?
		jnc	@@1			; chyba
		not	al
		mov	cs:[bx + offset fddbuf], al
		inc	cs:buf_ptr
		pop	ax
		pop	bx
		ret
@@1:		mov	cs:fdd_err, 0ffh	; chyba
		pop	ax
		pop	bx
		ret

out_fdddata	endp

		EVEN

inp_fdddata	proc	near

		push	ax
		mov	bx, cs:buf_ptr
		cmp	bx, cs:sect_size
		jnc	@@1			; chyba
		mov	al, cs:[bx + offset fddbuf]
		not	al			; vsechno musi byt invertovany
		inc	cs:buf_ptr
		mov	bl, al
		pop	ax
		ret
@@1:		pop	ax
		ret

inp_fdddata	endp

		EVEN

out_fdd_on_off	proc	near

		pop	bx
		mov	cs:fddon, bh
		xor	bh, cs:cfgDisk
		and	bh, 1
		mov	cs:pc_drive, bh
		ret

out_fdd_on_off	endp

		EVEN

out_fddside	proc	near

		pop	bx
		mov	cs:side, bh
		ret

out_fddside	endp

		EVEN

inp_fddside	proc	near

		mov	bh, cs:side
		ret

inp_fddside	endp


; ===========================================

setup720	proc	near

		cmp	cs:track, 0feh		; stopa 1 ?
		jnz	@@02
		cmp	cs:sector, 0feh		; sektor 1 ?
		jnz	@@02
		test	cs:side, 1              ; hlava 0 ?
		jnz	@@02
		mov	ah, 17h
		mov	al, 2
		mov	dl, cs:pc_drive
		int	13h
		mov	ah, 18h
		mov	ch, 79
		mov	cl, 9
		mov	dl, cs:pc_drive
		int	13h
@@02:		ret

setup720	endp


readsec		proc

		mov	cs:frekvmotor, 0	; nevypinej
		pusha				; save all
		call	set_secsize
@@str:		mov	ax, cs
		mov	es, ax
		mov	ax, 201h		; prikaz, cti jeden sektor
		mov	ch, cs:track
		mov	cl, cs:sector
		not	cx
		mov	dh, cs:side
		and	dh, 1
		mov	dl, cs:pc_drive
		mov	bx, offset fddbuf
		int	13h			; precti
		mov     cs:fdd_err, 0
		jnc	@@1
		cmp	cs:sect_size, 256	; 256 byte na sektor ?
		jnz     @@01
		mov	ax, 0
		mov	dl, cs:pc_drive
		int	13h			; znovu
		mov	cs:sect_size, 512
		call	sect512
		jmp	@@str
@@01:		mov	cs:fdd_err, 0ffh	; chyba
		call	setup720
		mov	ax, 0
		mov	dl, cs:pc_drive
		int	13h
@@1:		busy	<1>			; po nahrani sektoru
		mov	cs:buf_ptr, 0
		mov	es, cs:seg_ROM
		popa
		mov	cs:frekvmotor, MOTORDLY
		ret

readsec		endp

; ===========================================

writesec	proc

		mov	cs:frekvmotor, 0	; nevypinej ...
		pusha				; save all
		call	set_secsize
		mov	bp, 3
@@str:		mov	ax, cs
		mov	es, ax
		mov	ax, 301h		; prikaz, zapis jeden sektor
		mov	ch, cs:track
		mov	cl, cs:sector
		not	cx
		mov	dh, cs:side
		and	dh, 1
		mov	dl, cs:pc_drive
		mov	bx, offset fddbuf
		int	13h			; precti
		mov     cs:fdd_err, 0
		jnc	@@1
		cmp	cs:sect_size, 256
		jnz	@@01
		mov	ax, 0
		mov	dl, cs:pc_drive
		int	13h
		mov	cs:sect_size, 512
		call	sect512
		jmp	@@str
@@01:		mov	cs:fdd_err, 0ffh	; chyba
		mov	ax, 0
		mov	dl, cs:pc_drive
		int	13h
		dec	bp
		jnz	@@str
@@1:		mov	cs:busy_status, 0	; a je to konec
		mov	es, cs:seg_ROM
		popa
		mov	cs:frekvmotor, MOTORDLY
		ret

writesec	endp

; ===========================================

fdd_init	proc	near

		push	ax
		xor	ax, ax
		mov	cs:track, al
		mov	cs:sector, al
		mov	cs:busycnt, al
		mov	cs:fdd_err, al
		mov	cs:busy_status, al
		mov	cs:pc_drive, al
		mov	cs:buf_ptr, ax
		mov	cs:fddon, al
		mov	cs:sts_ok, al
		mov	cs:sect_size, ax
		push	es
		xor	ax, ax
		mov	es, ax
		mov	ax, es:[1eh * 4]
		mov	cs:Old1E, ax
		mov	ax, es:[1eh * 4 + 2]
		mov	cs:Old1E + 2, ax
		pop	es
		pop	ax
		ret

fdd_init	endp

restoreFDD	proc	near

		ret

restoreFDD	endp

storeFDD	proc	near

		ret

storeFDD	endp
