#include <dos.h>
#include <mem.h>
#include <fcntl.h>
#include <io.h>
#include <string.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

struct modStru {
int ID;
unsigned char hardware;                  // How hardware ?
unsigned mSeg;                           // Hlavni segment
unsigned segSamples[31];   		 // Segmenty samplu
unsigned begPatt;			 // zacatecni pattern
char One;				 // 0 = vsechny; 1 = jenom jeden
} mStru;

struct sHead {
char name[22];
unsigned size;
unsigned loopS;
unsigned loopE;
unsigned nic;
};

struct modHead {
char modName[20];
sHead heads[31];
unsigned char numPatt;
char nic;
unsigned char sequence[128];
char MK [4];
char patterns;
};

modHead far *pModHead;
char modFilename[78];

void eraseModule()
{
  if ( mStru. mSeg != 0 ) freemem( mStru. mSeg );
  for (int i = 0; i < 31; i++)
    if ( mStru. segSamples[i] != 0 ) freemem( mStru. segSamples[i] );
}

unsigned swapBytes( unsigned x )
{
  _AX = x;
  asm xchg ah, al
  return _AX;
}

int moduleLoad()
{
  int Handle;
  int maxP;

  setmem( &mStru, sizeof(mStru), 0 );
  if ( ( Handle = open( modFilename, O_RDONLY | O_BINARY ) ) == -1 )
    return 1;
  if ( allocmem( (1084 / 16) + 1, &mStru. mSeg ) != -1 )
    {
      close( Handle );
      return 1;
    }
  (void *)pModHead = MK_FP( mStru. mSeg, 0 );
  read( Handle, pModHead, 1084 );
  maxP = -1;		// pocet patternu
  for (int i = 0; i < pModHead -> numPatt; i++)
    if ( maxP < pModHead -> sequence[i] ) maxP = pModHead -> sequence[i];
  if ( setblock( mStru. mSeg, ((1084 / 16) + 1) + (64 * (maxP + 1)) )
		!= -1 )
    {
      eraseModule();
      close( Handle );
      return 1;
    }
  read( Handle, &(pModHead -> patterns), 1024 * (maxP + 1) );
  for ( i = 0; i < 31; i++ )
    {
      unsigned size = swapBytes( pModHead -> heads[i]. size ) << 1;
      if ( size > 0 )
	{
	  if ( allocmem( ( size >> 4 ) + 1, &mStru. segSamples[i] ) != - 1 )
	    {
	      eraseModule();
	      close( Handle );
	      return 1;
	    }
	  read( Handle, MK_FP( mStru. segSamples[i], 0 ), size );
	}
    }
  return 0;		// loaded ok ...
}

extern "C" void mod_play();

void modulePlay()
{
  mStru. ID = 'MP';
  _DX = FP_SEG( &mStru );
  _CX = FP_OFF( &mStru );
  mod_play();
}

extern "C" void mod_end();

void moduleEnd()
{
  mod_end();
}

extern char dosFile[78];
extern char directory[78];

int far _loadds eModulePlay()
{
  strcpy( modFilename, directory );
  strcat( modFilename, "\\" );
  strcat( modFilename, dosFile );
  if ( moduleLoad() ) return 1;
  modulePlay();
  return 0;
}

void far _loadds eModuleEnd()
{
  moduleEnd();
  eraseModule();
}

extern "C" setMusicPtrs( void far *, void far * );

void playInit()
{
  setMusicPtrs( eModulePlay, eModuleEnd );
}
